' This is a DEMO application to pulse the Barionet relays.
' It supports the CGI command interface (/basic.cgi?) and the UDP command interface on port 12300.
' The following command syntax is supported :
' pulse,x,y

' x is the relay register value and can be 1 , 2 ,3 or 4
' y is the pulse timer value, and can be 0 or values above 299 ms.
' As timing value use for one second = 1000, for one minute = 60000 and for one hour = 3600000.
' e.g. : pulse,2,500          pulses relay every 500 ms

' The command is case sensitive !
 
DIM resp$
DIM cmd$(20)
DIM cmd_cgi$
DIM rport
DIM rhost$(16)
DIM uu, cp, ln


SYSLOG "Demo to set pulse relay counter , SG v1.00"

OPEN "UDP:0.0.0.0:12300"   AS 1						'UDP command port

ON UDP GOSUB 100
ON CGI GOSUB 111

ON TIMER1 GOSUB 201
ON TIMER2 GOSUB 202
ON TIMER3 GOSUB 203
ON TIMER4 GOSUB 204

'-----------------------
1 ' Main loop
'-----------------------
Delay 1
GOTO 1
END

	
'checks received command from UDP port
'----------------------------------------------------------------
100 
ln = LASTLEN(1)
    IF ln < 0 THEN
      rhost$ = RMTHOST$(1)
      rport = RMTPORT(1)
      READ 1,cmd$ : SYSLOG "UDP command input: "+cmd$
      resp$="<NACK/>"
      	  IF MID$(cmd$,1,6) = "pulse," THEN
         	cp = INSTR(7,cmd$,",")        						'comma pos
         	uu = VAL(MID$(cmd$,7,cp-7))   						'get relay number from request
		value=VAL(MID$(cmd$,cp+1)) 						'get pulse timer value from request
		If AND(value < 299,value > 0) THEN 					'dont execute is timer value is too low
			resp$="Invalid value, note such low values can shorten the relay life !!" 
			SYSLOG resp$ 
			GOTO 101
			ELSE
				ON uu GOSUB 201,202,203,204
				Timer uu, value	 						'set according Timer
				IF value = 0 THEN GOSUB 299					'go to final turn off
         			resp$="<ACK/>"					                'prepare ACK
		ENDIF
101         cmd$=""
          WRITE 1,resp$,0,rho$,rport						'send confirmation
        ENDIF
      ENDIF
RETURN


'CGI command excution
'------------------------------------------------------------------
111 
  cmd_cgi$ = _CGI_$
  _CGI_$ = ""
    IF LEN(cmd_cgi$) > 0 THEN
       SYSLOG "CGI command input: " + cmd_cgi$, 1
       resp$="<NACK/>"
	  IF MID$(cmd_cgi$,1,6) = "pulse," THEN
         	cp = INSTR(7,cmd_cgi$,",")        					'comma pos
         	uu = VAL(MID$(cmd_cgi$,7,cp-7))						'get relay from request
		value_c=VAL(MID$(cmd_cgi$,cp+1))					'get pulse timer value from request
		If AND(value_c < 299,value_c > 0) THEN 					'dont execute is timer value is too low
			resp$="Invalid value, note such low values can shorten the relay life !!" 
			SYSLOG resp$ 
			GOTO 112
			ELSE
				ON uu GOSUB 201,202,203,204
				Timer uu, value_c	 						'set according Timer
				IF value_c= 0 THEN GOSUB 299						'go to final turn off
         			resp$="<ACK/>"					                	'prepare ACK
		ENDIF
112     WRITE -1,"HTTP/1.1 200 OK\r\nConnection:close\r\nCache-Control:no-cache\r\nPragma:no-cache\r\n\r\n"+ resp$ + "\n",0
        ENDIF
      ENDIF
 _CGI_$ = "*"
RETURN


201
IOCTL 1,999
RETURN

202
IOCTL 2,999
RETURN

203
IOCTL 3,999
RETURN

204
IOCTL 4,999
RETURN

299
IOCTL uu, 0							' final relay turn off
RETURN


